/* 
 * Copyright 2008 TrickleStar Ltd
 * All Rights Reserved.
 * http://tricklestar.com
 *
 */

// configuration

var config = new Object();

config.weekdays = [true, true, true, true, true, false, false];
config.weekends = [false, false, false, false, false, true, true];
config.polltime = 1; // minutes
config.pref = new Object();



function updateConfigToServer() {
    o = new Object();
    o.config = config;
    serverSend('sys', 'set_config', true, o);
}

function recallConfig() {
    for (var i=0;i<6;i++) {
        var val = widget.preferenceForKey('config.weekdays.' + i);
        if (val == 'true') {
            config.weekdays[i] = true;
        }
        else {
            config.weekdays[i] = false;
        }

        val = widget.preferenceForKey('config.weekends.' + i);
        if (val == 'true') {
            config.weekends[i] = true;
        }
        else {
            config.weekends[i] = false;
        }
    }
    config.polltime = setPollTimeFromIndex(widget.preferenceForKey('net.polltime'));
}

function setPollTimeFromIndex(t) {
    config.polltime = indexToPollTime(t);
    updateConfigToServer();
}




var outcmd = null;
    
function writeConfigToFile(filename) {
    // make sure latest config is available
    // make sure we have home id recorded
    saveAllPrefs();
    outcmd = widget.system('/bin/cat > "' + filename + '"', configEnd);
    // get config into json
    var ctext = JSON.stringify(config);
    outcmd.write(ctext);
    outcmd.close();
}

function configEnd() {
    // done
}


function saveAllPrefs() {
    if (zwave) {
        if (zwave.devices) {
            for (var d in zwave.devices) {
                zwave.devices[d].saveDevPrefs();
            }
        }
        zwave.saveDevPrefs();
    }
}

function recallAllPrefs() {
    if (zwave) {
        if (zwave.devices) {
            for (var d in zwave.devices) {
                zwave.devices[d].recallDevPrefs();
            }
        }
    }
}


function setPreferenceForKey(pref, key) {
    if (widget) {
        widget.setPreferenceForKey(pref, key);
    }
    if (pref == null) {
        delete config.pref[key];
    }
    else {
        config.pref[key]=pref;
    }
}

function restoreConfigFromString(newString, home_id) {
    var newConfig = JSON.parse(newString);
    // check config
    if (zwave) {
        try {
            var hid = newConfig.pref['net.homeid'];
            if (home_id != hid) {
                return false;
            }
        }
        catch(err) {
        
        }
    }
    config = newConfig;
    for (var key in config.pref) {
        if (widget) {
            widget.setPreferenceForKey(config.pref[key], key);
        }
    }
    recallAllPrefs();
    return true;
}