// This file was generated by Dashcode from Apple Inc.
// You may edit this file to customize your Dashboard widget.

/* 
 * Copyright 2008 TrickleStar Ltd
 * All Rights Reserved.
 * http://tricklestar.com
 *
 */

//
// holds the link to zwave...
//
var zwave;
var logging;
var updateInterval;

var drawerTab='rules';
//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    logging = new Debug();
    logging.setLevel(logging.INFO);
    recallConfig();
    logging.info('starting widget load()');
    widget.setCloseBoxOffset(260,33)
    setupParts();
    turnOffBoxes();
    back.style.display="none";
    showVersion();
    checkInstall();
    var drawer = document.getElementById("drawer-box");
	drawer.style.left='325px';
    zwave = new ZWave();
    renderStatus();
    checkServerStatus(zwave); // this is to kick server into life if needed   
    zwave.zwstart(); // starts zwave ccommunications etc
    setHelpTopic('');
    startUpdates();

}

function openOnLeft() {
    //alert("window.screenX " + window.screenX);
    //alert("window.screen.width " + window.screen.width);

    var remainingSpace = (window.screen.width - window.screenX - 660);
    return (remainingSpace < 260);
}


function turnOffBoxes() {
    var fd = document.getElementById('front-dialog-box');
    fd.style.display = 'none';
    for (var i=1;i<=8;i++) {
        var eb = document.getElementById('box' + i);
        var ebd = document.getElementById('disp-dev-' + i);
        if (eb) {
            eb.style.display = 'none';
        }
        if (ebd) {
            ebd.style.display = 'none';
        }
    }

}


function stopUpdates() {
   clearInterval(updateInterval);
}


function startUpdates() {
    try {
        clearInterval(updateInterval);
    }
    catch(e) {
    // pass
    }
    updateInterval = setInterval('zwave.updateState()', 750);
}


//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    stopUpdates();
    stopServer();
    removeServer();
}

if (window.widget)
{
	widget.onremove = remove;
}
//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
    stopUpdates();
    hideDrawer();
    autoCheckForUpdate();
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    startUpdates();
    // Restart any timers that were stopped on hide
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}




//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
    
	// put the drawer away
	hideDrawer();
    hideDialog();
    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    backImg = document.getElementById('back-image');
    //backImg.style.backgroundImage = "Images/tsrear400375.png";
    back.style.display = "block";
	swapStackDevices(event);

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
    if (zwave) {
        zwave.enableDeviceTable = false;
    }
}

//
// hide the drawer 
//
function hideDrawer(event) 
{
	var itemToMove = document.getElementById("drawer-box");
	var moveToLeftPosition = 350;	// new left CSS value

	// Moving code
	var originalLeft = parseInt(document.defaultView.getComputedStyle(itemToMove, null).getPropertyValue("left"));
	var fadeHandler = function(a, c, s, f){ itemToMove.style.left = c + "px"; };
	new AppleAnimator(500, 13, originalLeft, moveToLeftPosition, fadeHandler).start();
		
}

//
// show the drawer
// 
function showDrawer()
{
    drawerTab = 'rules';
	var itemToMove = document.getElementById("drawer-box");
    var closeButton = document.getElementById('close-button');
	var moveToLeftPosition = 625;	// new left CSS value    
    if (openOnLeft()) {
        moveToLeftPosition = 0;
        closeButton.style.left="5px";
    }
    else {
        moveToLeftPosition = 625;
        closeButton.style.left="248px";
    }
    renderDrawer();
	// Moving code
	var originalLeft = parseInt(document.defaultView.getComputedStyle(itemToMove, null).getPropertyValue("left"));
	var fadeHandler = function(a, c, s, f){ itemToMove.style.left = c + "px"; };
	new AppleAnimator(500, 13, originalLeft, moveToLeftPosition, fadeHandler).start();
}


function swapDrawerDetails(event) {
    drawerTab = 'details';
    renderDrawer();
}

function swapDrawerRules(event) {
    drawerTab = 'rules';
    renderDrawer();
}

function swapDrawerSchedule(event) {
    drawerTab = 'schedule';
    renderDrawer();
}

function swapDrawerErrors(event) {
    drawerTab = 'errors';
    renderDrawer();
}


function setDrawerButton(bname) {
    var details_button = document.getElementById('btd-details');
    var rules_button = document.getElementById('btd-rules');
    var schedule_button = document.getElementById('btd-schedule');
    var errors_button = document.getElementById('btd-errors');
    var turn_on = document.getElementById('btd-' + bname);

    var hcol = "#e6e6e6";
    var offcol = "#4c4c4c";
    // unset all
    details_button.style.backgroundColor=offcol;
    rules_button.style.backgroundColor=offcol;
    schedule_button.style.backgroundColor=offcol;
    errors_button.style.backgroundColor=offcol;
    // set one tab on
    turn_on.style.backgroundColor=hcol;
    setHelpTopic('drawer-'+ bname);
}


//
// render the Drawer
//
function renderDrawer() {
    // find elements
    var stack = document.getElementById('drawer-stack').object;
    // first: get the right elements visible
    if (drawerTab == 'rules') {
        stack.setCurrentView('rules-view');
        renderDrawerRules();
        setDrawerButton('rules');
    }
    else if (drawerTab == 'details') {
        stack.setCurrentView('details-view');
        renderDrawerDetails();
        setDrawerButton('details');       
    }
    else if (drawerTab == 'schedule') {
        stack.setCurrentView('schedule-view');
        renderDrawerSchedule();
        setDrawerButton('schedule');        
    }
    else if (drawerTab == 'errors') {
        stack.setCurrentView('errors-view');
        renderDrawerErrors();
        setDrawerButton('errors');         
    }
}


function renderDrawerRules() {
    if (selected >=1 && selected <=8) {
        var dev = zwave.getFrontDevice(selected);
        if (dev) {
            dev.renderRules();
        }
    } 
}

function renderDrawerSchedule() {
    if (selected >=1 && selected <=8) {
        var dev = zwave.getFrontDevice(selected);
        if (dev) {
            dev.renderSchedule();
        }
    } 
}

function renderDrawerErrors() {
    
    // get latest error log and set up
    // to refresh
    var errors = document.getElementById('errors-text');
    errors.innerHTML='';
    if (selected >=1 && selected <=8) {
        var dev = zwave.getFrontDevice(selected);
        if (dev) {
            dev.getLog();
        }
    }
}


//
// back side tab display
//

function setBackButton(bname) {
    var devices_button = document.getElementById('bt-devices');
    var other_button = document.getElementById('bt-other');
    var preferences_button = document.getElementById('bt-prefs');
    var errors_button = document.getElementById('bt-errors');
    var about_button = document.getElementById('bt-about');    
    var turn_on = document.getElementById('bt-' + bname);
    var hcol = "#e6e6e6";
    var offcol = "#4c4c4c";

    // unset all
    devices_button.style.backgroundColor=offcol;
    other_button.style.backgroundColor=offcol;
    preferences_button.style.backgroundColor=offcol;
    errors_button.style.backgroundColor=offcol;
    about_button.style.backgroundColor=offcol;
    devices_button.style.backgroundColor=offcol;
    //turn on the on on
    turn_on.style.backgroundColor=hcol;
    setHelpTopic('back-'+ bname);
}

function hideDialog() 
{
    var dialog = document.getElementById('dialog-box');
    dialog.style.display="none";
}

function swapBackTabDevices(event)
{
	var devices=document.getElementById('box-devices');
	var preferences=document.getElementById('box-preferences');
	var other=document.getElementById('box-other');

    var dialog = document.getElementById('dialog-box');
    var errors = document.getElementById('box-errors');
    errors.style.display="none";
    dialog.style.display="none";
	preferences.style.display="none";
	other.style.display="none";
	devices.style.display="inline";
    setBackButton('devices');
    // render device list here
    if (zwave != null) {
        zwave.enableDeviceTable = true;
        zwave.renderDeviceTable(content);
        var scroller=document.getElementById('scrollArea').object;
        scroller.refresh();
    }
}

function swapStackDevices(event) {
    var stack = document.getElementById('back-stack').object;
    var content = document.getElementById('box-content');
    var scroller=document.getElementById('scrollArea').object;
    stack.setCurrentView('stack-devices');
    setBackButton('devices');
    // render device list here
    if (zwave != null) {
        zwave.enableDeviceTable = true
        zwave.renderDeviceTable(content);
        scroller.refresh();
    }
}




function swapBackTabPreferences(event) 
{
	var devices=document.getElementById('box-devices');
	var preferences=document.getElementById('box-preferences');
	var other=document.getElementById('box-other');
    var errors = document.getElementById('box-errors');
    errors.style.display="none";
	other.style.display="none";
	devices.style.display="none";
	preferences.style.display="inline";
    setBackButton('prefs');
    renderPreferences();
}

function swapStackPreferences(event)
{
    var stack = document.getElementById('back-stack').object;
    stack.setCurrentView('stack-preferences');
    setBackButton('prefs');
    renderPreferences();

}

function swapBackTabOther(event) 
{
	var devices=document.getElementById('box-devices');
	var preferences=document.getElementById('box-preferences');
	var other=document.getElementById('box-other');
    var errors = document.getElementById('box-errors');
    errors.style.display="none";    
	devices.style.display="none";
	preferences.style.display="none";
	other.style.display="inline";
    setBackButton('other-button');
    renderUSBStickStatus();
}

function swapStackOther(event)
{
    var stack = document.getElementById('back-stack').object;
    stack.setCurrentView('stack-other');
    setBackButton('other');
    renderUSBStickStatus();
}

function swapBackTabErrors(event) 
{
	var devices=document.getElementById('box-devices');
	var preferences=document.getElementById('box-preferences');
	var other=document.getElementById('box-other');
    var errors = document.getElementById('box-errors');
    errors.style.display="inline";
	devices.style.display="none";
	preferences.style.display="none";
	other.style.display="none";
    setBackButton('errors');
    if (zwave) { 
        zwave.getLog();
    }
}

function swapStackErrors(event)
{
    var stack = document.getElementById('back-stack').object;
    stack.setCurrentView('stack-errors');
    setBackButton('errors');
    if (zwave) { 
        zwave.getLog();
    }
}

function swapStackAbout(event)
{
    var stack = document.getElementById('back-stack').object;
    stack.setCurrentView('stack-about');
    setBackButton('about');
    if (zwave) { 
        zwave.getLog();
    }
}


function renderUSBStickStatus() {
    var usbs = document.getElementById('usb-stick-status');
    var stat_text = '...';
    if (zwave && zwave.myController) {
        if (zwave.myController.isPrimary()) {
            stat_text = 'Primary Controller';
        }
        else if (zwave.myController.isSecondary()) {
            stat_text = 'Secondary Controller';
        }
        else if (zwave.myController.isInclusion()){
            stat_text = 'Inclusion Controller';
        }
        else {
        }
        usbs.innerHTML=stat_text;
    }
}




function renderPreferences() {
    for (var i=0;i<7;i++) {
        var wd = document.getElementById('wd' + i);
        var we = document.getElementById('we' + i);
        var wdval = widget.preferenceForKey('config.weekdays.' + i);
        if (wdval == 'true') {
            wd.checked = true;
        }
        else {
            wd.checked = false;
        }
        var weval = widget.preferenceForKey('config.weekends.' + i);
        if (weval == 'true') {
            we.checked = true;
        }
        else {
            we.checked = false;
        }
    }
    
    // and language
    //var la = document.getElementById('language');
    //var lang = widget.preferenceForKey('display.language');
    //logging.info('language is: ' + lang);
    // persist changing language
    //la.object.setSelectedIndex(lang);
    // and poll time
    var pt = document.getElementById('poll-time');
    var ptIndex = widget.preferenceForKey('net.polltime');
    pt.object.setSelectedIndex(ptIndex);
    
}




function onOff(event) {
	if (event.srcElement.innerHTML=='On') {
		event.srcElement.style.color='#ff0000';
		event.srcElement.innerHTML='Off';
	}
	else {
		event.srcElement.style.color='#00ff00';
		event.srcElement.innerHTML='On';
	}
}

function setOn() {
	var rit = document.getElementById('OnOff1');
	rit.style.color='#00ff00';
	rit.innerHTML='On';
	var itemToMove = document.getElementById("drawer-box");
	itemToMove.style.left='325px';
}

// handle toggle of on/off or dimmer status as onclick event
function toggle(event, index, chan) {
    if (zwave) {
        var dev = zwave.getFrontDevice(index);
        if (dev) {
            dev.toggle(chan);
            var element = event.srcElement;
            dev.renderUpdate(element, index);
        }
    }
}


//
// selected device on front of widget
// 

var selected = -1; // set to -1 when nothing is selected

//
// handler to select devices with single click from front side
//

function selectDevice(event) {
// decode the device from the name of the element
// that the event comes from...
    if (event != null) {
        if (event.srcElement != null) {
            var id = event.srcElement.id;
            var devNum = -1;
            if (startsWith(id,"box")) {
                devNum = parseInt(id.substring(3));
            }
            else if (startsWith(id, "deviceType")) {
                devNum = parseInt(id.substring(10));
            }
            else if (startsWith(id, "deviceName")) {
                devNum = parseInt(id.substring(11));
            }            
            if (devNum >= 1 && devNum <= 8) {
                var wasSelected = selected;
                selected = devNum;
                if (wasSelected > 0) {
                    var oldbox = document.getElementById('box' + wasSelected);
                    oldbox.style.border='none';
                }
                var selbox = document.getElementById('box' + devNum);
                selbox.style.border='thin solid yellow';
                renderDrawer();
            }
        }
    }
}

function selectDeviceFromIndex(index) {
    var wasSelected = selected;
    selected = index;
    if (wasSelected > 0) {
        var oldbox = document.getElementById('box' + wasSelected);
        oldbox.style.border='none';        
    }
    var selbox = document.getElementById('box' + index);
    selbox.style.border='thin solid yellow';
    renderDrawer();
}

function renderStatus() {
    var uis = document.getElementById("usb-int-status-box");
    if (zwave.getUSBInterfaceState()) {
        uis.innerHTML = '<img src="Images/statusgreen.png" width="6px" height="6px"/>';
    }
    else {
        uis.innerHTML = '<img src="Images/statusred.png" width="6px" height="6px"/>';
    }
    var zns = document.getElementById("zwave-net-status-box");
    if (zwave.getZWaveState()) {
        zns.innerHTML = '<img src="Images/statusgreen.png" width="6px" height="6px"/>';
    }
    else {
        zns.innerHTML = '<img src="Images/statusred.png" width="6px" height="6px"/>';
    }

}

//
// render drawer details - and other tabs
//
function renderDrawerDetails() {
    if (selected >=1 && selected <=8) {
        var dev = zwave.getFrontDevice(selected);
        if (dev) {
            placeText('home-id', dev.home_id);
            placeText('node-id', dev.node_id);
            var el=document.getElementById('keypairs');
            dev.renderKeyPairs(el);
        }
    }
}


//
// helper function to render text to named element
// 
function placeText(id, text) {
    var element = document.getElementById(id);
    if (element) {
        element.innerHTML=text;
    }
}

function placeHexText(id, text) {
    placeText(id, text);
}


//
// handle setting of dimmer by slider
//




//
//
// swapping of drawer boxes --- based on buttons being clicked
//
//



//
//
// rendering of drawer boxes
//
//







if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}


function s(event)
{
    // Insert Code Here
}


function excludeHandler(event)
{
    // check we are allowed to do this
    if (zwave) {
        var myc = zwave.myController;
        if (myc) {
            var d = new Dialog();
            var result = serverSend('net', 'start_remove', true, null);
            d.onStop('Exclude a device', 'Click button on the device you wish to remove from the network.  Exclusion will time out in 15 seconds.', excludeStopHandler);

            // when Exclude button is pressed, put network into removal mode
            if (zwave) {
                zwave.widgetMode = 'start_exclude';
            }     
        }
        else {
            var d = new Dialog();
            d.alert('Can not Exclude', 'You do not have a controller to run exclude on.');
        }
    }
}

function excludeStopHandler(event) {
    // remove dialog is visible
    var d = new Dialog();
    d.hide();
    var result = serverSend('net', 'stop_remove', true, null);
    if (zwave) {
        zwave.widgetMode = 'run';
    } 
}

function includeHandler(event)
{
    // check we are allowed to do this
    if (zwave) {
        var myc = zwave.myController;
        if (myc && (myc.isPrimary() || myc.isInclusion())) {    
            // dialog
            var d = new Dialog();
            var result = serverSend('net', 'start_add', true, null);
            d.onStop('Include a New Device', 'Click button on the device you wish to add to the network.  Inclusion will time out in 15 seconds.', includeStopHandler);
            // kick off the process
            if (zwave) {
                zwave.widgetMode = 'start_include';
            }
        }
        else {
            var d = new Dialog();
            d.alert('Can not Include', 'Your USB stick is not a primary or inclusion controller, and can not include devices.');
        }
    }
}

function includeStopHandler(event) {
    // remove dialog if visible
    var d = new Dialog();
    d.hide();
    var result = serverSend('net', 'stop_add', true, null);
    if (zwave) {
        zwave.widgetMode = 'run';
    }
}

function devcheckhandler(cb, ni) {
    var val = "no";
    if (cb.checked) {
        val = "yes";
    }
    setPreferenceForKey( val, "dev." + ni + ".front")
    // and sort out the front side so re-rendered
    zwave.clearFrontSide();
}

function pollTimeHandler(ev) {
    var pt = document.getElementById('poll-time')
    // persist changing poll time
    var index = pt.object.getSelectedIndex();
    logging.info('poll minutes changed to ' + indexToPollTime(index));
    setPreferenceForKey( index, "net.polltime");
    // and communicate it to the server
    setPollTimeFromIndex(index);
}

var pollTimes = [1, 5, 10, 30,45, 60];

function indexToPollTime(index) {
    return pollTimes[index];
}

/*
function languageHandler(ev) {
    var la = document.getElementById('language');
    // persist changing language
    var lang = la.object.getSelectedIndex();
    logging.info('language changed to ' + lang);
    widget.setPreferenceForKey( lang, 'display.language');
    // and change the localized language value
    // and save in plugin config
    // TODO
}
*/

function notimp(event)
{
    var d = new Dialog();
    d.alert('Not yet', 'This function is not implemented');
}

function dhide(event) {
    var d = new Dialog();
    d.hide();
}

function contResetConfirmed(event) {
    dhide(event);
    // go ahead with controller reset
    serverSend('net', 'reset_controller', true, null);
}

function contResetA(event)
{
    // Controller reset beginning
    // put up Are You Sure dialog
    //
    d = new Dialog();
    d.onConfirm('Are you sure you want to reset the controller?  All network settings will be lost?', contResetConfirmed);
}

function sendConfig(event) {
    updateConfigToServer();
}



//
// 
//
function setDays(event)
{
    // update prefs. and save to proper config
    //alert(event.srcElement.id + event.srcElement.checked);
    var id = event.srcElement.id;
    var ss = id.substring(0,2);
    var n = parseInt(id.substring(2));
    var par = 'false';
    if (event.srcElement.checked) {
        var par = 'true';
    }
    if (ss == 'wd') {
        config.weekdays[n]=event.srcElement.checked;
        config.weekends[n]=!par;
        var wend = document.getElementById('we'+n);
        wend.checked = !par;
        setPreferenceForKey(par, 'config.weekdays.' + n);
    }
    else { //we
        config.weekends[n]=event.srcElement.checked;
        config.weekdays[n]=!par;
        var wday = document.getElementById('wd'+n);
        wday.checked = !par;
        setPreferenceForKey(par, 'config.weekends.' + n);
    }
    updateConfigToServer();
}


function ruleChangeHandler(event)
{
    // use selected to find device
    // do updates
        if (selected >=1 && selected <=8) {
        var dev = zwave.getFrontDevice(selected);
        if (dev) {
            dev.updateRules();
        }
    }
}

function ruleCancelHandler(event) {
    if (selected >=1 && selected <=8) {
        var dev = zwave.getFrontDevice(selected);
        if (dev) {
            dev.renderRules();
        }
    }
}

function scheduleChangeHandler(event)
{
    // do updates
    if (selected >=1 && selected <=8) {
        var dev = zwave.getFrontDevice(selected);
        if (dev) {
            dev.updateSchedule();
        }
    }
}

function scheduleCancelHandler(event) {
    if (selected >=1 && selected <=8) {
        var dev = zwave.getFrontDevice(selected);
        if (dev) {
            dev.renderSchedule();
        }
    }
}


function showDiags(event)
{
    widget.openURL('file:///tmp/zwserver.log');
}






function resetPlugin(event)
{
    widget.system('launchctl stop com.tricklestar.pyzwave');
    widget.system('launchctl start com.tricklestar.pyzwave');    
}


function replicateHandler(event)
{
    // handle replication command
    // check for controller mode
    serverSend('net', 'request_network_update', true, null);
    //d = new Dialog();
    //d.alert('Not available', 'The USB controller can not replicate another controller when it is the primary controller');
    
}


function testSleep(event)
{
    // Fire command to plugin to test go-to-sleep rules
    serverSend('net', 'system_sleep', true, null);
}


function testPcOff(event)
{
    // Fire command to plugin to test go-to-sleep rules
    serverSend('net', 'system_shutdown', true, null);
}


function testPcOn(event)
{
    // Fire command to plugin to test go-to-sleep rules
    serverSend('net', 'system_startup', true, null);
}


function addToNetworkHandler(event)
{
    // Add USB device to network
    serverSend('net', 'add_to_network', true, null);

}


function clearNetLog(event)
{
    if (zwave) {
        zwave.clearLog();
    }
}


function refreshNetLog(event)
{
    if (zwave) {
        zwave.getLog();
    }
}



function replicateFromHandler(event)
{
    // This is really just the same as add to network,
    // so we just do that
    addToNetworkHandler(event);
}

function replicateToHandler(event)
{
    // check we are allowed to do this
    if (zwave) {
        var myc = zwave.myController;
        if (myc && (myc.isPrimary() || myc.isInclusion())) {    
            // dialog
            var d = new Dialog();
            o = new Object();
            o.replicate_controller = true;
            var result = serverSend('net', 'start_add', true, o);
            d.onStop('Replicate to another controller', 'Active the controller you wish to replicate to.  See your controller\'s documentation for how to do this.  Inclusion will time out in 15 seconds.', includeStopHandler);
            // kick off the process
            if (zwave) {
                zwave.widgetMode = 'start_include';
            }
        }
        else {
            var d = new Dialog();
            d.alert('Replication not supported', 'Your USB stick is not a primary or inclusion controller, and can not replicate to other controllers.');
        }
    }
}




function logoClickHandler(event)
{
    widget.openURL('http://tricklestar.com');
}

var restoreDialog = null;

function restoreAllConfig(event)
{
    var info = 'To restore configuration, drag the file and drop it here.<br/><br/><span class="hint">Hint: find the file in the Finder, start to drag it and, while holding the mouse button down, press F12 to bring up this widget. And drop it here.</span>';
    restoreDialog = new Dialog();
    restoreDialog.setDropHandler(restoreFromFile);
    restoreDialog.alertCancelOnly('Restore Configuration', info);
    
}

function restoreFromFile(event) {

    try {
        // Obtain the URIs of the dropped items
        var uriString = event.dataTransfer.getData("text/uri-list");	
        
        // Split the URIs into an array
        var uriList = uriString.split("\n");
        // get first dropped file item
        var configFileURI = uriList[0];
        if (!endsWith(configFileURI, '.tsj')) {
            //not compatible file
            restoreDialog.alert('File not compatible', 'This file is not a valid configuration.');
            return;
        } 
        if (!startsWith(configFileURI, 'file://')) {
            restoreDialog.alert('File not compatible', 'You must drag a local file to restore a configuration.');
            return;
        }
        var fileParts = configFileURI.split('/');
        var path = '/' + (fileParts.slice(3)).join('/');
        // now read file in to memory
        var cmd = widget.system('/bin/cat ' + path, null);

        var newConfig = cmd.outputString;
        if (zwave) {
            var cont = zwave.getMyController();
            var homeid = cont.home_id;
        } else {
            var homeid = 0;
        }
        if (!restoreConfigFromString(newConfig, homeid)) {
            restoreDialog.alert('Network does not match', 'The restored confguration is for a different network and can not be restored.');
            return;
        }
    
        restoreDialog.hide();
    } catch (ex) {
        
        alert("Problem fetching URI: " + ex);
    }

}

function endsWith(base, part) {
    return (base && part && base.length >= part.length && base.substring(base.length - part.length, base.length) == part);
}

function startsWith(base, part) {
    return (base && part && base.length >= part.length && base.substring(0, part.length) == part);
}

var saveDialog = null;

function saveAllConfig(event) {
    // save configuration
    saveDialog = new Dialog();
    saveDialog.cancelOKDialog('Save Configuration', 'Config files are saved onto your Desktop.  Please enter a name for this configuration:<br/><br/><input type="text" id="savefname" name="savefname" size="15"/>', getFileSave);
}

var saveName = null;

function getFileSave() {
    var input = document.getElementById('savefname');
    var fname = input.value;
    var homedir = widget.system("/bin/sh -c \"echo $HOME\"", null).outputString;
    homedir = strim(homedir);
    saveDialog.hide();
    saveDialog = new Dialog();
    fname += ".tsj";
    saveName = homedir + '/Desktop/' + fname;
    saveDialog.cancelOKDialog('Save Configuration', 'Your config will be saved to your Desktop, in file called ' + fname, doActualSave);
}


function doActualSave() {
    writeConfigToFile(saveName);
    saveDialog.hide();
}

function strim(sInString) {
  sInString = sInString.replace( /^\s+/g, "" );// strip leading
  return sInString.replace( /\s+$/g, "" );// strip trailing
}

function dragEnter(event)
{
	event.stopPropagation();
	event.preventDefault();
}
function dragOver(event)
{
	event.stopPropagation();
	event.preventDefault();
}




// Help
var helpTopic='';

function setHelpTopic(topic) {
    helpTopic=topic;
}

function getHelp(event) {
    var base='http://www.tricklestar.com/files/uploads/TrickleStar_Widget_Help.html#'
    widget.openURL(base + helpTopic);
}
