#!/usr/bin/env python
# encoding: utf-8
"""
devicelog.py

Created by Graeme Sutherland on 2008-06-17.
Copyright (c) 2008 TrickleStar Limited. All rights reserved.
"""

import sys
import os
import unittest
import time

class DeviceLog:
    """
    A log for each device.  There's one per device, and it has a limited size
    """
    
    def __init__(self, log_length=30):
        self.log = []
        self.log_length = log_length

    def _add_entry(self, entry):
        if len(self.log) >= self.log_length:
            del self.log[0]
        t = time.strftime("%H:%M:%S", time.localtime())
        self.log.append(t + ' ' + entry)
    
    def info(self, i):
        self._add_entry('Info: ' + i)
        
    def warning(self, info):
        self._add_entry('Warning: ' + info)

    def error(self, info):
        self._add_entry('Error: ' + info)

    def get_log(self):
        return self.log
    
    def clear(self):
        self.log = []
        self.info('cleared log')

class DeviceLogTests(unittest.TestCase):
    def setUp(self):
        pass
        
    def test_log(self):
        lo = DeviceLog()
        for i in range(40):
            lo.warning('hello %d' % i)
        print repr(lo.get_log())

if __name__ == '__main__':
    unittest.main()