#!/usr/bin/env python
# encoding: utf-8
"""
sleepcatch.py

Created by Graeme Sutherland on 2008-07-23.
Copyright (c) 2008 Presence Labs Limited. All rights reserved.
"""

import sys
import os
import time
import threading

if __name__ == '__main__':
    #Platform-based messing around
    plat='x86'
    osv = '10.5'
    vi = sys.version_info
    if vi[1] == 3:
        osv='10.4'
    if sys.byteorder=='big':
        plat='ppc'
    slibpath="../libs/%s/%s" % (plat, osv)
    print slibpath
    sys.path = [slibpath, './growl', './sleepcatch'] + sys.path

from _sleepcatch import *



class Sleepcatch(object):
    def __init__(self, callback):
        self.callback  = callback
        self._reg_sleepcatch()
    
    def _reg_sleepcatch(self):
        set_power_callback(self.callback)
        initpower()        



class PowerThread(threading.Thread):
    def __init__(self):
        threading.Thread.__init__(self)

    def run(self):
        self.sc = Sleepcatch(printit)
        while True:
            poll_loop()
            time.sleep(0.1)


def printit(event):
    print event
    
def main():
    p = PowerThread()
    p.start()
    i=0
    while True:
        time.sleep(1)
        print i
        i = i+1

if __name__ == '__main__':
	main()

