#!/usr/bin/env python
# encoding: utf-8
"""
zwbasecommand.py

Created by Graeme Sutherland on 2008-03-07.
Copyright (c) 2008 TrickleStar Limited. All rights reserved.
"""
__version__ = "$Revision: 7 $"

import sys
import os
import unittest
import exceptions

class ZWBaseCommand:
    """
    Base command class, subclassed for particular behaviours.  A base command ought to be able to assemble,
    send itself, receive and decode initial ack and then expeced responses/callbacks
    """
    def __init__(self, serial):
        self.cmd_id = -1
        self.cmd_type = -1
        self.frame = None
        self.wait_for_response=False
        self.name = 'BaseCommand'
        self.serial = serial
    
    def get_frame(self):
        return self.frame
    
    def send(self):
        """docstring for send"""
        self.frame.match = self.match
        self.serial.send_frame(self.frame, self.wait_for_response)


class ZWCommandFailedError(exceptions.Exception):
    def __init__(self, args):
        self.args = args

class ZWBaseCommandTests(unittest.TestCase):
    def setUp(self):
        pass


if __name__ == '__main__':
    unittest.main()