#!/usr/bin/env python
# encoding: utf-8
"""
zwconfig.py

Created by Graeme Sutherland on 2008-05-01.
Copyright (c) 2008 TrickleStar Limited. All rights reserved.
"""
import logging
import os
import sys
import pickle
import pwd
import simplejson

# default config is here
config = {
    'weekdays': [True, True, True, True, True, False, False],
    'weekends': [False, False, False, False, False, True, True],
    'polltime': 1
}

default_config = {
    'weekdays': [True, True, True, True, True, False, False],
    'weekends': [False, False, False, False, False, True, True],
    'polltime': 1
}

def get_config():
    """get config dict"""
    global config
    return config

def put_config(c):
    global config
    logging.debug('got new config: ' + repr(c))
    config = c 

def get_config_item(name):
    global config
    return config[name]

def log_config():
    global config
    for k in config.keys():
        logging.debug('config: %s: %s', k, repr(config[k]))
        
def save_config(model):
    global config
    if model and model.devices:
        d = {}
        for k in model.devices.keys():
            d[k] = model.devices[k].config
        config['devices'] = d
    f = open(get_config_filename(), 'w')
    js = simplejson.dumps(config)
    f.write(js)
    f.close()
    
    
def get_device_config(node_id):
    if config.has_key('devices') and config['devices'].has_key(str(node_id)):
        return config['devices'][str(node_id)]
    else:
        return None

    
    
def load_config():
    global config
    global default_config
    try:
        f = open(get_config_filename(), 'r')
        js = f.read()
        config = simplejson.loads(js)
        f.close()
    except:
        config = default_config
        try:
            f.close()
        except:
            pass
    
    
def get_config_filename():
    """return name for config file"""
    # firstly, find the basic info we need
    user_info = pwd.getpwuid(os.getuid())
    username =  user_info.pw_name
    home_dir = user_info.pw_dir
    config_filename = os.path.join(home_dir, 'Library/Preferences/com.tricklestar.pyzwave.pref')
    return config_filename