#!/usr/bin/env python
# encoding: utf-8
"""
zwconstants.py

Created by Graeme Sutherland on 2008-03-03.
Copyright (c) 2008 TrickleStar Limited. All rights reserved.
"""


ACK = 0x06
NAK = 0x15
CAN = 0x18
SOF = 0x01

# Type: Used to distinguish between unsolicited calls and immediate 
# responses (not callback). The request (REQ) is equal to 0x00 and 
# response (RES) is equal to 0x01. 
REQ = 0x00
RES = 0x01

# for nodeinfo
NODE_BROADCAST = 0xff

#
# controller capabilities
#
# Defines for ZW_GetControllerCapabilities 
CONTROLLER_IS_SECONDARY = 0x01
CONTROLLER_ON_OTHER_NETWORK = 0x02
CONTROLLER_NODEID_SERVER_PRESENT = 0x04
CONTROLLER_IS_REAL_PRIMARY = 0x08
CONTROLLER_IS_SUC = 0x10

# Library type
ZW_LIB_CONTROLLER_STATIC = 0x01
ZW_LIB_CONTROLLER        = 0x02
ZW_LIB_SLAVE_ENHANCED    = 0x03
ZW_LIB_SLAVE             = 0x04
ZW_LIB_INSTALLER         = 0x05
ZW_NO_INTELLIGENT_LIFE   = 0x06

# SendData transmit options

TRANSMIT_OPTION_ACK = 0x01
TRANSMIT_OPTION_LOW_POWER = 0x02
TRANSMIT_OPTION_AUTO_ROUTE = 0x04
TRANSMIT_OPTION_NO_ROUTE = 0x10

TRANSMIT_COMPLETE_OK     =  0x00
TRANSMIT_COMPLETE_NO_ACK  = 0x01  # retransmission error 
TRANSMIT_COMPLETE_FAIL    = 0x02  # transmit error 
TRANSMIT_ROUTING_NOT_IDLE = 0x03  # transmit error 
TRANSMIT_COMPLETE_NOROUTE = 0x04  # no route found in assignroute 

UPDATE_STATE_NODE_INFO_RECEIVED    = 0x84
UPDATE_STATE_NODE_INFO_REQ_DONE    = 0x82
UPDATE_STATE_NODE_INFO_REQ_FAILED  = 0x81
UPDATE_STATE_ROUTING_PENDING       = 0x80
UPDATE_STATE_ADD_DONE              = 0x40
UPDATE_STATE_DELETE_DONE           = 0x20
UPDATE_STATE_SUC_ID                = 0x10

# TRICKLESTAR constants
MANUF_TRICKLESTAR = [0x0,0x6b]

#Alarm Type:  0x00 = Surge Protection Status 
#Alarm Value: 0x00 = Surge Protection OK 
#  0x01 = Surge Protection malfunctioning 
#Alarm Type:  0x01 = Mains Earth Connection Status 
#Alarm Value: 0x00 = Earth Connected 
#  0x01 = Earth Not Connected

ALARM_TYPE_NAMES=['Surge Protection','Mains Earth']