#!/usr/bin/env python
# encoding: utf-8
"""
install.py

Installer for launchd and similar startup items... make sure the pyzwave server
starts when the system starts

Created by Graeme Sutherland on 2008-07-03.
Copyright (c) 2008 TrickleStar Limited. All rights reserved.
"""

import sys
import os
import pwd

plist_source = """
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
<plist version="1.0">
<dict>
	<key>KeepAlive</key>
	<true/>
	<key>Label</key>
	<string>%(job_label)s</string>
	<key>WorkingDirectory</key>
	<string>%(pyzwave_base)s</string>
	<key>ProgramArguments</key>
	<array>
		<string>/usr/bin/env</string>
		<string>python</string>
		<string>zwserver.py</string>
		<string>-q</string>
		<string>-l</string>
	</array>
	<key>QueueDirectories</key>
	<array/>
	<key>RunAtLoad</key>
	<true/>
	<key>WatchPaths</key>
	<array/>
	<key>OnDemand</key>
	<false/>
</dict>
</plist>
"""


def killer():
    findcmd = 'ps axe | grep zwserver.py | grep -v grep'
    s = findcmd.split(' ')
    

def main():
    # serious constants
    job_label = 'com.tricklestar.pyzwave'
    
    # firstly, find the basic info we need
    user_info = pwd.getpwuid(os.getuid())
    username =  user_info.pw_name
    home_dir = user_info.pw_dir
    current_dir = os.getcwd();
    print 'home directory: ' + home_dir
    print 'current_dir: ' + current_dir
    # then some derived paths
    
    launchd_dir = home_dir + '/Library/LaunchAgents/'
    
    app_support_dir = home_dir + '/Library/Application Support/TrickleStar'
    findme_file = os.path.join(app_support_dir, 'widgetbasepath.txt')
    
    launchd_file = os.path.join(launchd_dir, job_label + '.plist')
    
    basedir = current_dir  

    pyzwave = os.path.join(basedir, 'pyzwave')
    server = os.path.join(pyzwave, 'zwserver.py')
    
    print 'file is: ' + __file__
    print 'widget at: ' + basedir
    print 'pyzwave at: ' + pyzwave
    print 'server is: ' + server
    print 'launchd file is: ' + launchd_file


    # make directory if doesn't exist
    try:
        os.mkdir(launchd_dir, 0755)
    except:
        pass
    
    try:
        os.mkdir(app_support_dir, 0755)
    except:
        pass

    # unload existing
    r = os.system('launchctl unload %s' % launchd_file)
    print('launchctl unload returned %d' % r)

    # kill just in case
    rr = os.system("kill -INT `ps axe | grep zwserver.py | grep -v grep | awk '{print $1}'`")
    
    # and if really stuck, just once
    rrr = os.system("kill -9 `ps axe | grep zwserver.py | grep -v grep | awk '{print $1}'`")
    

    # write the findme file
    f = open(findme_file, "w")
    f.write(basedir)
    f.close()

    # run launchd script through the templating to get correct values
    ld_map = {
        'pyzwave_base': pyzwave,
        'job_label': job_label
    }
    s = plist_source % ld_map
    
    # write the file
    
    f = open(launchd_file, "w")
    f.write(s)
    f.close()
    
    # and invoke it -- can invoke with widget anyway, this will just get things going quicker
    # have to do sleep stuff -- but that ought to be done via IO kit from python

    r1 = os.system('launchctl load %s' % launchd_file)
    print('launchctl load returned %d' % r)
    
    r2 = os.system('launchctl start %s' % job_label)
    print('launchctl start returned %d' % r)    
    
    sys.exit(r1)
if __name__ == '__main__':
    main()

