/* 
 * Copyright 2008 TrickleStar Ltd
 * All Rights Reserved.
 * http://tricklestar.com
 *
 */
 
 
var baseURL = "http://127.0.0.1:4344/ezw/"
var checkURL = baseURL + "sys/check"
var starter_cmd;
var req;
var server_cmd = "/usr/bin/env python pyzwave/zwserver.py -D -q"

//
// change this for releases
//

var auto_start = false;

var serverStatus = null;
var serverStarting = false;




function checkServerStatus(zwave) {
    try {
        var serverStatus = serverSend('sys', 'status', false, null);
        if (zwave) {
            zwave.setServerStatus(serverStatus);
            serverStarting = false;
        }
        if (serverStatus == null) {
            autoStartServer();
        }
    }
    catch(e) {
        // problem, so start a server
        zwave.setServerStatus(null);
        autoStartServer();
    }
}

function checkInstall() {
    // called at starup to check the right version of plugin is available
    var thisVersion = getKeyValue("Info.plist", "CFBundleVersion");
    var installedVersion = widget.preferenceForKey('plugin.installedVersion');
    logging.info('installed version is ' + installedVersion + ' this version is ' + thisVersion);
    if (thisVersion != installedVersion) {
        logging.info('installing new plugin version');
        starter_cmd = widget.system('/usr/bin/env python scripts/install.py ' + thisVersion, installEnd);
    }
}

function installEnd(info) {
    logging.info('installer finished! (' + info.status + ') ' + info.errorString);
    logging.info('installer output: ' + info.outputString);
    if (info.status == 0) {
        var thisVersion = getKeyValue("Info.plist", "CFBundleVersion");
        widget.setPreferenceForKey(thisVersion, 'plugin.installedVersion');
    }
}

function removeServer() {
    widget.setPreferenceForKey(null, 'plugin.installedVersion');
    logging.info('removing widget');
    widget.system('/bin/launchctl unload "$HOME/Library/LaunchAgents/com.tricklestar.pyzwave.plist"');
    widget.system('rm -f "$HOME/Library/LaunchAgents/com.tricklestar.pyzwave.plist"');
    removeEnd(null);
}

function removeEnd(info) {
    logging.info('uninstall complete');
    widget.setPreferenceForKey(null, 'plugin.installedVersion');
}


function stopServer() {
    // try and stop the server.. quick request, don't restart it to tell it to stop
    req =  new XMLHttpRequest();
    req.onreadystatechange = null;
    req.open('GET', 'http://127.0.0.1:4344/ezw/sys/stop', false);
    try {
        req.send();
    }
    catch(e) {
        req = false;
    }
    serverStarting = false;
}


function autoStartServer() {
    if (auto_start) {
        startServer();
    }
}

function startServer() {
    if (!serverStarting) {
        logging.info('starting server');
        serverStarting = true;
        starter_cmd = widget.system(server_cmd, startEnd);
    }
}

function startEnd(info) {
    alert('server has exited! (' + info.status + ') ' + info.errorString);
    serverStarting = false;
}

//
// Sending commands to server
//

function serverSend(subject, verb, async, args) {
    var a = null;
    if (args != null) {
        a = args;
    }
    else {
        a = new Object();
    }
    a['subject'] = subject;
    a['verb'] = verb;
    return serverSendRaw(async, null, a);
}

function serverSendCatch(subject, verb, async, fn, args) {
    var a = null;
    if (args != null) {
        a = args;
    }
    else {
        a = new Object();
    }
    a['subject'] = subject;
    a['verb'] = verb;
    return serverSendRaw(async, fn, a);
}

// send a message, return an object, hopefully usefully
function serverSendRaw(async, fn, args) {
    var url = baseURL + 'go';
    var postvars = JSON.stringify(args);
    logging.debug('>sending: ' + postvars);
    var req =  new XMLHttpRequest();
    if (fn != null) {
    var olhandler =  function() {
            fn(req);
        };
        req.onload=olhandler;
    }
    else {
        req.onreadystatechange = reqStateChange;
    }
    req.open('POST', url, async);
    try {
        req.send(postvars);
    }
    catch(e) {
        logging.debug('-Send Failed:' + e);
        return null;
    }
    if (!async) {
        if (req.status != 200) {
            logging.debug('-Failed: ' + req.status + ' ' + req.statusText);
            return null;
        }
        else {
            logging.debug('<receiving:' + req.responseText);
            if (req.responseText) {
                return JSON.parse(req.responseText);
            }
            else {
                return {};
            }
        }
    }
}

function reqStateChange() {
}

